/*! \mainpage Task Description
 *
 * Implement the functions below.
 *
 * Unless stated otherwise, all the functions are expected to return nothing.
 *
 * REQUIREMENT: you must use smart pointers in this task.
 *
 * @file
 */

#include "solution.hpp"

/**
 * Returns the number of elements in the list.
 * @return number of elements in the list.
 */
size_t MyList::size() const {
    return 0;
}

/**
 * Adds a new element with the specified value to the beginning of the list as the first element.
 * @param a the value of the list node.
 */
void MyList::push_front(int a) {}

/**
 * Adds a new element with the specified value to the end of the list as the last element.
 * @param a the value of the list node.
 */
void MyList::push_back(int a) {}

/**
 * Inserts a new element at with the specified value at a given position in the list.
 *
 * If the list consists of N elements, admissible positions are in the range [0,N].
 * If the specified position does not belong to this range, the function must throw an instance of std::runtime_error.
 * In any other abnormal situations the function must throw an instance of std::runtime_error.
 *
 * @param a the value of the list node.
 * @param pos position at which the new node must appear in the list.
 */
void MyList::insert(int a, size_t pos) {}

/**
 * Removes a list element at a given position from the list.
 *
 * If the list contains N elements, admissible positions are in the range [0,N-1].
 * If the specified position does not belong to this range, the function must throw an instance of std::runtime_error.
 * In any other abnormal situations the function must throw an instance of std::runtime_error.
 *
 * @param pos position at which the node is removed from the list.
 */
void MyList::remove(size_t pos) {}

/**
 * The function must print all the values of all the elements in the list,
 * in a single string separated by whitespace characters.
 *
 * @param os an output stream
 * @param list an instance of a linked list
 * @return an output stream
 */
std::ostream &operator<<(std::ostream &os, const MyList &list) {}

/**
 * The random access operator allows to access list elements at specified positions.
 *
 * If a list contains N elements, valid positions are in the range [0,n-1].
 * If the specified position does not belong to this range, the function must throw an instance of std::runtime_error.
 * In any other abnormal situations the function must throw an instance of std::runtime_error.
 *
 * @param pos position at which the value of the corresponding node is being returned
 * @return a reference to the list node value
 */
int &MyList::operator[](size_t pos) {
    int x = 0;
    return x;
}

/**
 * The random access operator allows to access list elements at specified positions.
 *
 * If a list contains N elements, valid positions are in the range [0,n-1].
 * If the specified position does not belong to this range, the function must throw an instance of std::runtime_error.
 * In any other abnormal situations the function must throw an instance of std::runtime_error.
 *
 * @param pos position at which the value of the corresponding node is being returned
 * @return a copy of the list node value
 */
const int &MyList::operator[](size_t pos) {
    int x = 0;
    return x;
}

