#include <gtest/gtest.h>
#include "solution.hpp"

TEST(MyList, createEmpty) {
    MyList list;
    ASSERT_EQ(list.begin,nullptr);
    ASSERT_EQ(list.size(),0);
}

TEST(MyList, listPushOperation1) {
    MyList list;
    ASSERT_EQ(list.begin,nullptr);
    list.push_back(2);
    ASSERT_NE(list.begin,nullptr);
    ASSERT_EQ(list.size(),1);
    ASSERT_EQ(list[0],2);
    list.push_front(3);
    ASSERT_EQ(list.size(),2);
    ASSERT_EQ(list[0],3);
    ASSERT_EQ(list[1],2);
}

TEST(MyList, listPushOperation2) {
    MyList list;
    list.push_front(2);
    ASSERT_NE(list.begin,nullptr);
    ASSERT_EQ(list.size(),1);
    list.push_back(3);
    ASSERT_EQ(list.size(),2);
    ASSERT_EQ(list[0],2);
    ASSERT_EQ(list[1],3);
}

TEST(MyList, listPushOperation3) {
    MyList list;
    list.push_back(2);
    ASSERT_NE(list.begin,nullptr);
    ASSERT_EQ(list.size(),1);
    list.push_back(3);
    ASSERT_EQ(list.size(),2);
    ASSERT_EQ(list[0],2);
    ASSERT_EQ(list[1],3);
}

TEST(MyList, listPushOperation4) {
    MyList list;
    list.push_front(2);
    ASSERT_NE(list.begin,nullptr);
    ASSERT_EQ(list.size(),1);
    list.push_front(3);
    ASSERT_EQ(list.size(),2);
    ASSERT_EQ(list[0],3);
    ASSERT_EQ(list[1],2);
}

TEST(MyList, listInsertOperation) {
    MyList list;
    ASSERT_EQ(list.size(),0);
    try {
        list.insert(1,1);
        FAIL();
    } catch (const std::runtime_error& e) {
        SUCCEED();
    }
    list.insert(1,0);
    ASSERT_EQ(list.size(),1);
    ASSERT_EQ(list[0],1);
    try {
        list.insert(1,2);
        FAIL();
    } catch (const std::runtime_error& e) {
        SUCCEED();
    }
    list.insert(2,0);
    ASSERT_EQ(list.size(),2);
    ASSERT_EQ(list[0],2);
    ASSERT_EQ(list[1],1);
    list.insert(3,1);
    ASSERT_EQ(list.size(),3);
    ASSERT_EQ(list[0],2);
    ASSERT_EQ(list[1],3);
    ASSERT_EQ(list[2],1);
    list.insert(4,3);
    ASSERT_EQ(list.size(),4);
    ASSERT_EQ(list[0],2);
    ASSERT_EQ(list[1],3);
    ASSERT_EQ(list[2],1);
    ASSERT_EQ(list[3],4);
}

TEST(MyList, listRemoveOperation) {
    MyList list;
    ASSERT_EQ(list.size(),0);

    try {
        list.remove(0);
        FAIL();
    } catch (const std::runtime_error& e) {
        SUCCEED();
    }
    list.push_back(10);
    list.push_back(11);
    list.push_back(12);
    list.push_back(13);
    list.push_back(14);
    list.push_back(15);
    ASSERT_EQ(list.size(),6);
    try {
        list.remove(6);
        FAIL();
    } catch (const std::runtime_error& e) {
        SUCCEED();
    }
    list.remove(4);
    ASSERT_EQ(list.size(),5);
    ASSERT_EQ(list[0],10);
    ASSERT_EQ(list[1],11);
    ASSERT_EQ(list[2],12);
    ASSERT_EQ(list[3],13);
    ASSERT_EQ(list[4],15);
    list.remove(3);
    ASSERT_EQ(list.size(),4);
    ASSERT_EQ(list[0],10);
    ASSERT_EQ(list[1],11);
    ASSERT_EQ(list[2],12);
    ASSERT_EQ(list[3],15);
    list.remove(1);
    ASSERT_EQ(list.size(),3);
    ASSERT_EQ(list[0],10);
    ASSERT_EQ(list[1],12);
    ASSERT_EQ(list[2],15);
    list.remove(0);
    ASSERT_EQ(list.size(),2);
    ASSERT_EQ(list[0],12);
    ASSERT_EQ(list[1],15);
}
